/* math_parser_compat.c */
/* Functions which are not available on all platforms and math functions which are C99 only */
#include "math_parser_compat.h"

#ifndef HAVE_STRDUP
char* strdup(const char *s){
	char *dest=(char*)malloc(strlen(s)+1);
	if (dest) strcpy(dest,s);
	return dest;
}
#endif

#ifndef USE_C99
double round(double in){
	return (fabs(in-floor(in))<=0.5 ? floor(in) : ceil(in));
}
#endif

