/*math_parser_gtk2_helperfns.c*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "math_parser_gtk2.h"
#include "math_parser_gtk2_helperfns.h"

/*Callbacks*/
gboolean bool_set_false(GtkWidget *nw,GdkEvent *ne,bool *b){
	return *b=false;
}
gboolean change_int_opt(GtkSpinButton *sb,int* prop){
	*prop=gtk_spin_button_get_value_as_int(sb);
	redraw_graph();
	return TRUE;
}
gboolean opt_subopt_active(GtkToggleButton* main, GtkWidget* sub){
	gtk_widget_set_sensitive(sub,gtk_toggle_button_get_active(main));
	return TRUE;
}

gboolean colorbutton_changed(GtkColorButton *cb,GdkColor *col){
	gtk_color_button_get_color(cb,col);
	redraw_graph();
}
gboolean fontbutton_changed(GtkFontButton *fb,char* s[]){
	*s=gtk_font_button_get_font_name(fb);
}

void PangoLayout_setfont_str(PangoLayout *pl,const char str[]){
	PangoFontDescription *desc=pango_font_description_from_string(str);
	pango_layout_set_font_description(pl,desc);
	pango_font_description_free(desc);
}

char* dbltocstr(double dbl,int len){
	char *abc=(char*)malloc(len);
	snprintf(abc,len,"%f",dbl);
	return abc;
}
char* inttocstr(int i,int len){
	char *abc=(char*)malloc(len);
	snprintf(abc,len,"%i",i);
	return abc=(char*)realloc(abc,strlen(abc)+1);
}

/*Dialogs*/
void ShowErrorDlg(const char errtxt[]){
	GtkWidget *d=gtk_message_dialog_new(NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_WARNING,GTK_BUTTONS_CLOSE,errtxt,NULL);
	gtk_dialog_run(GTK_DIALOG(d));
	gtk_widget_destroy(d);
}
char* filedialog_generic(bool opendialog,char caption[], char* pattern[][2],int pairnum){
	char *filename=NULL;
	int i;
	GtkFileFilter *filt[pairnum];
	GtkWidget *dialog=gtk_file_chooser_dialog_new(caption,NULL,
		(opendialog ? GTK_FILE_CHOOSER_ACTION_OPEN : GTK_FILE_CHOOSER_ACTION_SAVE),
		GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,
		(opendialog ? GTK_STOCK_OPEN : GTK_STOCK_SAVE),
		GTK_RESPONSE_ACCEPT,NULL);
	for (i=0;i<pairnum;++i){
		filt[i]=gtk_file_filter_new();
		gtk_file_filter_add_pattern(filt[i],pattern[i][0]);
		gtk_file_filter_set_name(filt[i],pattern[i][1]);
		gtk_file_chooser_add_filter((GtkFileChooser*)dialog,filt[i]);
		fprintf(stderr,"filter %d\n",i);
	}
	if(gtk_dialog_run(GTK_DIALOG(dialog))==GTK_RESPONSE_ACCEPT)
		filename=gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
	gtk_widget_destroy(dialog);
	return filename;
}
bool file_exists(const char filename[]){
	FILE *abc=fopen(filename,"r");
	if(!abc) return false;
	fclose(abc);
	return true;
}
bool file_exists_dialog(const char filename[]){
	/* simple replacement for overwrite confirmation not available in GTK 2.4 */
	bool a;
	if(!filename) return false;
	if(file_exists(filename)){
		GtkWidget *d=gtk_message_dialog_new(NULL,GTK_DIALOG_MODAL,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,"File exists. Overwrite?");
		a=gtk_dialog_run(GTK_DIALOG(d));
		gtk_widget_destroy(d);
		return (a==GTK_RESPONSE_YES);
	}
	return true;
}

bool bf_algo_draw(parser_context *pc){
	int i=1;
	/*performs one iteration, the action associated is in caller */
		i=pc->par.num-1;
again:
	if((pc->par_t[i-1].intvl>0 == pc->par.values[i]+pc->par_t[i-1].intvl<pc->par_t[i-1].end) || pc->par.values[i]+pc->par_t[i-1].intvl==pc->par_t[i-1].end)
		pc->par.values[i]+=pc->par_t[i-1].intvl;//i++
	else if(i>0){
		pc->par.values[i]=pc->par_t[i-1].begin;--i;goto again;
	}
	else return /*done=*/true;/*last possibility reached*/
	return false;
}

double round_2 /* bad name, but i dont know a better one right now */(double in,int aftercomma){
char tmpout[100],tmpcomma[25];
snprintf(tmpout,25,"%%.%d%c",aftercomma,'f');
snprintf(tmpout,100,tmpcomma,in);
return atof(tmpout);
}
