/* Converter from mgd (MatheGrafix 6.02build02+) files to ini used by Andrea's Funktionsrechner */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
char *filetostr(char filename[], int *len){
	long count=0;
	char tmp;
	char *out=(char*)calloc(10,1);
	FILE *abc=fopen(filename,"r");
	if(!abc) return NULL;
	while (!feof(abc)){
		tmp=getc(abc);
		out[count++]=tmp;
		if (count%10==8)
			out=realloc(out,count+10);
	}
	*len=count;
	return out;
}

void mgd2ini(const char *mgd,const char *ini){
	int i,len;
	FILE *out;
	char *in=filetostr(mgd,&len);
	out=fopen(ini,"w");
	if (!in || !out) return;
	if(len<100000) return;
	fprintf(out,"[Andis Funktionsrechner-0.5]\n");
	fprintf(out,"ceq=%c\n",in[8]);
	for(i=0;i<9;++i)
		fprintf(out,"str%i=%.255s\n",i,&in[5321+(i-1)*584]);
	fclose(out);

}


void mgdinfo(char *mgdin){
	int len;
	char *cont=filetostr(mgdin,&len);
	assert(cont);
	if(!cont || len<100000){
		printf("Fehler: mgd viel zu kurz!\n");
		return;
	}
	printf("Aktuelle Funktion: %i\n",cont[8]+'0');
	printf("X-Achsenbeschriftung: %s\n",cont+57);
	printf("Y-Achsenbeschriftung: %s\n",cont+312);
	printf("Y-Massstab: %s cm\n",cont+569);
	printf("X-Massstab: %s cm\n",cont+825);
	printf("aktueller Funktionsstring: %s\n",cont+2881);
	printf("aktuelle untere Zeichengrenze: %s\n",cont+1601);
	printf("aktuelle obere Zeichengrenze: %s\n",cont+1857);
	printf("X-Einzelwert: %s\n",cont+3137);
	printf("Einzelergebnis: %s\n",cont+3650);
	printf("Aktuelle Funktion: %.255s\n",cont+3905);//4671
	for (int i=1;i<=9;++i){
		printf("%i. Funktion: %.255s\n",i,&cont[5321+(i-1)*584]);
		printf("%i. Funktion ist eine %.255s\n",i,&cont[5576+(i-1)*584]);
	}
	free(cont);
}
#ifdef STANDALONE
int main(int argc,char* argv[]){
	if(argv[1]){
		mgdinfo(argv[1]);
		if (argv[2])
			mgd2ini(argv[1],argv[2]);
	}
}
#endif
